Subject: Sub-Requests losing arguments
Description

A sub-request losing its arguments it a route is defined with defaults.

Associated revisions
Revision 7e643f7b - 2014-09-30 09:18 - Christian Müller

[BUGFIX] Merge request arguments instead of overwrite

A sub-request losing its arguments if a route is defined f.e. like this:
-
  name: 'Basket Steps'
  uriPattern: '{node}/{--pipeu_factura_nodetypes-basket.@action}.{@format}'
  defaults:
    '@package': 'TYPO3.Neos'
    '@controller': 'Frontend\Node'
    '@format': 'html'
    '@action': 'show'
    '--pipeu_factura_nodetypes-basket':
      '@package': 'PIPEU.Factura.NodeTypes'
      '@controller': 'Basket'
  routeParts:
    node:
      handler: TYPO3\Neos\Routing\FrontendNodeRoutePartHandler
  appendExceedingArguments: true

In this case '--pipeu_factura_nodetypes-basket' will override
any pluginArgument because of a missing check for existing
index in pluginArguments. Its getting replaced instead of merged.

This wrong behavior is fixed with this patch by merging instead of
overwriting.

Same for internal arguments.

Was fixed in master by the related feature.

Related: I1d192231810757f38aecfc3f7dc520b118ee3feb
Change-Id: Ib067912327cb07cc6fff91d1fe5b3e5c6cd9ccdb
Resolves: #59404
Releases: master, 2.2, 2.1

Revision bbf90a4a - 2014-09-30 09:25 - Christian Müller

[BUGFIX] Merge request arguments instead of overwrite

A sub-request losing its arguments if a route is defined f.e. like this:
-
  name: 'Basket Steps'
  uriPattern: '{node}/{--pipeu_factura_nodetypes-basket.@action}.{@format}'
  defaults:
    '@package': 'TYPO3.Neos'
    '@controller': 'Frontend\Node'
    '@format': 'html'
    '@action': 'show'
    '--pipeu_factura_nodetypes-basket':
      '@package': 'PIPEU.Factura.NodeTypes'
      '@controller': 'Basket'
  routeParts:
    node:
      handler: TYPO3\Neos\Routing\FrontendNodeRoutePartHandler
  appendExceedingArguments: true

In this case '--pipeu_factura_nodetypes-basket' will override
any pluginArgument because of a missing check for existing
index in pluginArguments. Its getting replaced instead of merged.

This wrong behavior is fixed with this patch by merging instead of
overwriting.

Same for internal arguments.

Was fixed in master by the related feature.

Related: I1d192231810757f38aecfc3f7dc520b118ee3feb
Change-Id: Ib067912327cb07cc6fff91d1fe5b3e5c6cd9ccdb
Resolves: #59404
Releases: master, 2.2, 2.1

History
#1 - 2014-06-07 16:11 - Gerrit Code Review
- Status changed from New to Under Review

Patch set 6 for branch master of project Packages/TYPO3.Flow has been pushed to the review server.
It is available at https://review.typo3.org/30562

#2 - 2014-06-07 16:14 - Gerrit Code Review

Patch set 7 for branch master of project Packages/TYPO3.Flow has been pushed to the review server.
It is available at https://review.typo3.org/30562

#3 - 2014-06-07 16:16 - Gerrit Code Review

Patch set 8 for branch master of project Packages/TYPO3.Flow has been pushed to the review server.
It is available at https://review.typo3.org/30562

#4 - 2014-08-10 15:33 - Gerrit Code Review

Patch set 9 for branch master of project Packages/TYPO3.Flow has been pushed to the review server.
It is available at http://review.typo3.org/30562

#5 - 2014-09-04 12:22 - Gerrit Code Review

Patch set 10 for branch master of project Packages/TYPO3.Flow has been pushed to the review server.
It is available at http://review.typo3.org/30562

#6 - 2014-09-21 16:16 - Carsten Bleicker
- File 201409211409527b16a6.txt added

Provided a Site Package wich let you see the problem and the resulting exception.
Please see: https://bitbucket.org/cbleicker/typo3.neosdemotypo3org/src/5dea4b055946488b5e905a480243fa3feb0e705c?at=develop

You need to enable the routes of the site package to reproduce it.
Please see Line 19 of:
https://bitbucket.org/cbleicker/typo3.neosdemotypo3org/src/5dea4b055946488b5e905a480243fa3feb0e705c/Configuration/Routes.yaml?at=develop#
l-19

Site export contains a new page node called "Basket" wich has a plugin to show the behaviour.

#7 - 2014-09-30 09:18 - Gerrit Code Review

Patch set 1 for branch 2.2 of project Packages/TYPO3.Flow has been pushed to the review server.
It is available at http://review.typo3.org/33050

#8 - 2014-09-30 09:25 - Gerrit Code Review

Patch set 1 for branch 2.1 of project Packages/TYPO3.Flow has been pushed to the review server.
It is available at http://review.typo3.org/33051

#9 - 2014-10-26 02:00 - Christian Müller
- Status changed from Under Review to Resolved
- % Done changed from 0 to 100
Applied in changeset commit:7e643f7b00ed624b8385f5f02f2862eaba43d40c.

Files
201409211409527b16a6.txt 16.6 kB 2014-09-21 Carsten Bleicker
